/***********************************************************************************************
   				wmSMPmon - moniteur systeme pour Window Maker
VERSION	: 1.2
DATE	: 18/08/99
AUTEUR	: RedSeb <red_seb@yahoo.com>
UTILITE : A tous les possesseurs de WM ET de bi-proc!
************************************************************************************************
   				   Ce programme est sous GPL.
***********************************************************************************************/



#include	<linux/sys.h>
#include 	<sys/param.h>
#include 	<sys/types.h>
#include	"standards.h"
#include 	<X11/Xlib.h>
#include 	<X11/xpm.h>
#include 	<X11/extensions/shape.h>
#include 	<sensors/sensors.h>
#include 	<sensors/chips.h>
#include 	<sensors/error.h>
#include 	"../wmgeneral/wmgeneral.h"
#include 	"../wmgeneral/misc.h"
#include 	"wmSMPmon_master.xpm"
#include 	"wmSMPmon_mask.xbm"



int main(int argc, char **argv)
{
   int 		delay = 250000 ;
        
   FILE		*p_file, *m_file ;

   char			c = 4,
      			tmp[128],
      			rien[16] ;

   unsigned long	usr1, usrn1, sys1, idle1, charge1, total1,
      			usr2, usrn2, sys2, idle2, charge2, total2,
                        total1o = 0, charge1o = 0,
      			total2o = 0, charge2o = 0,
      			mem[8] = { 0, 0, 0, 0, 0, 0, 0, 0} ;


   if(((p_file = fopen("/proc/loadavg", "r")) == NULL)
   || ((m_file = fopen("/proc/meminfo", "r")) == NULL))
   {
      return(ERREUR) ;
   }

   openXwindow(argc,argv,wmSMPmon_master_xpm,wmSMPmon_mask_bits,wmSMPmon_mask_width,wmSMPmon_mask_height) ;

   while(VRAI)
   {
      p_file = freopen("/proc/stat", "r", p_file);

/*************** lecture de la charge des processeurs */
      fgets(tmp, 128, p_file) ;
      fgets(tmp, 128, p_file) ;
      sscanf(tmp, "%s %lu %lu %lu %lu",
      	       rien, &usr1, &usrn1, &sys1, &idle1) ;
      fgets(tmp, 128, p_file) ;
      sscanf(tmp, "%s %lu %lu %lu %lu",
               rien, &usr2, &usrn2, &sys2, &idle2) ;

/*************** lecture de l'occupation mmoire */
      if(c > 2)
      {
         m_file = freopen("/proc/meminfo", "r", m_file) ;
         fgets(tmp, 128, m_file) ;
         fgets(tmp, 128, m_file) ;
         sscanf(tmp, "%s %lu %lu %lu %lu %lu %lu",
         rien, &mem[1], &mem[2], &mem[3], &mem[3], &mem[3], &mem[3]) ;
         mem[0] = ((mem[2] - mem[3]) / (mem[1] / 100)) ;

/*************** lecture du swap */
      	fgets(tmp, 128, m_file) ;
        sscanf(tmp, "%s %lu %lu %lu", rien, &mem[5], &mem[6], &mem[7]) ;
        mem[4] = 100 - (mem[7] / (mem[5] / 100)) ;
        c = 0 ;
      }
      c ++ ;
/*************** criture du rsultat et sauvegarde de la charge du processeur */
      charge1 = usr1+usrn1+sys1 ;
      total1 = charge1+idle1 ;
      charge2 = usr2+usrn2+sys2 ;
      total2 = charge2+idle2 ; 

      copyXPMArea(26, 63, 26, 10, 33, 5) ;
      copyXPMArea(0, 63, (((charge1-charge1o) * 100 / (total1-total1o)) * 26 / 100), 10, 33, 5) ;

      copyXPMArea(26, 63, 26, 10, 33, 19) ;
      copyXPMArea(0, 63, (((charge2-charge2o) * 100 / (total2-total2o)) * 26 / 100), 10, 33, 19) ;

      copyXPMArea(26, 63, 26, 10, 33, 34) ;
      copyXPMArea(0, 63, (mem[0] * 26 / 100), 10, 33, 34) ;

      copyXPMArea(26, 63, 26, 10, 33, 48) ;
      copyXPMArea(0, 63, (mem[4] * 26 / 100), 10, 33, 48) ;

      total1o = total1 ;charge1o = charge1 ;
      total2o = total2 ;charge2o = charge2 ;
      RedrawWindow() ;
      usleep(delay);      
   }
}

